;(function () {
	var root = this;	
	var NewsApplication = root.NewsApplication = {};	
	NewsApplication.App = new Marionette.Application();
	NewsApplication.Vent = new Backbone.Wreqr.EventAggregator();
	
	var Router = Marionette.AppRouter.extend({
		appRoutes: {
			'': 'initial',
			'news' : 'news',
			'all' : 'initial',
			'economy' : 'economy',
			'technology' : 'technology',
			'entertainment' : 'entertainment',
			'lifestyle' : 'lifestyle',
			'sport' : 'sport',
			'news/(:newsItem)': 'storySelected',
			'news/(:newsItem)/(:map)': 'maps'
		}
	});
	NewsApplication.Router = new Router({
		controller: {
			
			initial: function () {
				Backbone.history.navigate('all');
				NewsApplication.Vent.trigger('category:all');
			},
			
			news: function () {
				console.log('News selected');
				NewsApplication.Vent.trigger('category:news');
			},

			economy: function () {
				console.log('economy selected');
				NewsApplication.Vent.trigger('category:economy');
			},

			technology: function () {
				console.log('technology selected');
				NewsApplication.Vent.trigger('category:technology');
			},

			entertainment: function () {
				console.log('entertainment selected');
				NewsApplication.Vent.trigger('category:entertainment');
			},

			lifestyle: function () {
				console.log('lifestyle selected');
				NewsApplication.Vent.trigger('category:lifestyle');
			},

			sport: function () {
				console.log('sport selected');
				NewsApplication.Vent.trigger('category:sport');
			},

			storySelected: function () {
				console.log('News article selected');
				NewsApplication.Vent.trigger('newsExtended');
			},

			maps: function () {
				console.log('Maps selected');
				NewsApplication.Vent.trigger('maps');
			}				
		}
	});
}).call(this);