;(function () {
	var root = this;
	var NewsApplication = root.NewsApplication;;
	var Regions = NewsApplication.Regions = {};
		
	Regions.Footer = Marionette.Region.extend({
		el: '#footer',
	});
	
	Regions.Header = Marionette.Region.extend({
		el: '#header',

		initialize: function () {
			var header = this;
			NewsApplication.Vent.on('filters', function () {
				header.show(new NewsApplication.Views.Filter());
			});

			NewsApplication.Vent.on('options', function() {
				header.show(new NewsApplication.Views.MoreOptions());
			});
		}
	});
	
	Regions.NewsContainer = Marionette.Region.extend({
		el: '#main',

		initialize: function () {
			var newsContainer = this;
			this.stories = new NewsApplication.Collections.Stories();
			
			NewsApplication.Vent.on('storySelected', function (model) {
				newsContainer.show(new NewsApplication.Views.NewsExtended({
					model: model
				}));
				Backbone.history.navigate(model.toJSON()['cat'][0].toLowerCase() + '/' + model.id);
			});
			
			NewsApplication.Vent.on('map', function (locations) {
				if (newsContainer.currentView.model) {
					newsContainer.showMap(newsContainer.currentView.model.get('location'));
				} else if (newsContainer.currentView.collection) {
					newsContainer.showMap(_.pluck(newsContainer.currentView.collection.toJSON(), 'location'));
				}
			});
			
			NewsApplication.Vent.on('category:all', function () {
				newsContainer.showNewsList('all');
			});
			
			NewsApplication.Vent.on('category:news', function () {
				newsContainer.showNewsList('news');
			});
			
			NewsApplication.Vent.on('category:economy', function () {
				newsContainer.showNewsList('economy');
			});
			
			NewsApplication.Vent.on('category:technology', function () {
				newsContainer.showNewsList('technology');
			});
			
			NewsApplication.Vent.on('category:lifestyle', function () {
				newsContainer.showNewsList('lifestyle');
			});
			
			NewsApplication.Vent.on('category:entertainment', function () {
				newsContainer.showNewsList('entertainment');
			});
			
			NewsApplication.Vent.on('category:sport', function () {
				newsContainer.showNewsList('sport');
			});
			
			NewsApplication.Vent.on('app:initialized', function () {
				if( ! Backbone.History.started) { 
					Backbone.history.start();
				}
			});
		},
		
		showNewsList: function (category) {
			this.single = false;
			this.stories.setCategory(category);
			this.show(new NewsApplication.Views.NewsList({
				collection: this.stories
			}));
		},
		
		showMap: function (locations) {
			this.show(new NewsApplication.Views.MapView(locations));
			Backbone.history.navigate("map");
		}
	});
	
	NewsApplication.App.addRegions({
		header: NewsApplication.Regions.Header,
		main: NewsApplication.Regions.NewsContainer,
		footer: NewsApplication.Regions.Footer
	});
}).call(this);