var express = require('express'),
	request = require('request'),
	app = express();

app.configure(function () {
	app.use(app.router);
	app.use(express.static(__dirname + '/public'));
});

app.configure('development', function() {
  	app.use(express.errorHandler({ dumpExceptions: true, showStack: true }));
});

app.configure('production', function() {
  	app.use(express.errorHandler());
});

var server = 'http://vm-6120.idi.ntnu.no:8080/solr/news/select?rows='; 
var query = '&wt=json&sort=published+desc&q=image-url:*%20AND%20lead-text:*%20AND%20text:*%20AND%20title:*%20AND%20cat:';

app.get('/stories', function(req, res) {
    var url = server;
    var category = req.query.category;
    var rows = req.query.rows;
    
    url += rows;
    url += query;
    url += category ? category : '*';

    console.log(url);
  	
    request(url, function (error, response, body) {
      res.end(body);
    });
});
app.listen(8080, '192.168.1.11');