;(function () {
	var root = this;
	var NewsApplication = root.NewsApplication;;
	
	var Models = NewsApplication.Models = {};
	var Collections = NewsApplication.Collections = {};

	Models.Story = Backbone.Model.extend({});
	
	Collections.Stories = Backbone.Collection.extend({
		model: Models.Story,
		
		rows: 10,
		category: '',

		url: function () {
			var url = 'http://192.168.1.11:8080/stories?rows=' + this.rows;

			if (this.category) {
				if (this.category !== 'all') {
					url += '&category=' + this.category 					
				}
			}
			return url;
		},

		parse: function (response) {
			var that = this;
			_.each(response.response.docs, function (story) {
				var tmp = new Models.Story();
				tmp.set('_version', story['_version']);
				tmp.set('cat', story.cat);
				tmp.set('id', story.id);
				tmp.set('image_url', story['image-url']);
				tmp.set('last_modified', story.last_modified);
				tmp.set('lead_text', story['lead-text']);
				tmp.set('links', story.links);
				tmp.set('location', story.location);
				tmp.set('published', story.published);
				tmp.set('publisher', story.publisher);
				tmp.set('score', story.score);
				tmp.set('sentiment_value', story['sentiment-value']);
				tmp.set('signature', story.signature);
				tmp.set('tags', story.tags);
				tmp.set('text', story.text);
				tmp.set('title', story.title);
				that.push(tmp);
			});
			return this.models;
		},

		initialize: function() {
			var that = this;
			
			NewsApplication.Vent.on('range', function (range) {
				that.setRows(range);
			});
		},

		appendToUrl: function (parameter) {
			this.baseUrl += '&' + parameter;
		},

		setRows: function (rows) {
			this.rows = rows;
			this.fetch({
				reset: true
			});
		},

		setCategory: function (category) {
			this.category = category;
		}
	});
}).call(this);